#include "showplayer.h"


ShowPlayer::ShowPlayer(QWidget *parent) :
    QDialog(parent)
  , ui(new Ui::ShowPlayer)
{
    ui->setupUi(this);
    connect(ui->addCueButton, SIGNAL(clicked()), this, SLOT(onAddTrack()));
    connect(ui->goButton, SIGNAL(clicked()), this, SLOT(go()));
     currentTrackIndex = 0;
    filesLoaded = 0;
    currentStatus = Status::Iddle;
}

ShowPlayer::~ShowPlayer() {}

void ShowPlayer::onAddTrack() {
	TrackDialog dialog;
    dialog.show();
	if (dialog.exec() == QDialog::Accepted) {
        ui->cueListWidget->addCueTrackWidget(dialog.track);
	}
}

void ShowPlayer::go()
{
	CueTrackWidget* current = ui->cueListWidget->getSelectedTrack();
	if (!current)
        return;
    for (int i = 0; i < MAX_LAYERS; i++) {
		if (layersUsed[i] == -1) {
			layersUsed[i] = currentTrackIndex;
			current->audioLayer = i;
			break;
		}
	}
	updateTrackStateInEngine(currentTrackIndex, current->audioLayer);
    emit uiLoadMedia(current->audioLayer, current->getFilePath());
    emit uiPlaybackChanged(current->audioLayer, current->getStatus());
	filesLoaded++;
}
