#include "trackdialog.h"
#include "settings.h"

TrackDialog::TrackDialog(QWidget *parent) : QDialog(parent) {
	setupUi();
	connectSignals();
}

void TrackDialog::setupUi() {
	okButton = new QPushButton(tr("OK"), this);
	cancelButton = new QPushButton(tr("Cancelar"), this);
    browseButton = new QPushButton(tr("Buscar..."), this);

    QFormLayout *layout = new QFormLayout(this);
    track = new CueTrack();
    layout->addRow(tr("&User number"), track->userNumber);
    layout->addRow(tr("&Name"), track->name);
    layout->addRow(tr("&Description"), track->description);
    layout->addRow(tr("&File"), track->filePath);
    layout->addRow(tr("&Browse files"), browseButton);
    layout->addRow(tr("&Status"), track->status);
    layout->addRow(tr("&Fade in"), track->fadeIn);
    layout->addRow(tr("Fade &Out"), track->fadeOut);
    layout->addRow(tr("&Wait In"), track->waitIn);
    layout->addRow(tr("&Wait Ou&t"), track->waitOut);
    layout->addRow(tr("Sto&p at end"), track->stopAtEnd);
    layout->addRow(tr("&Volume"), track->volume);
    layout->addRow(tr("pan"), track->pan);
    layout->addRow(tr("pitch"), track->pitch);
    layout->addRow(tr("Bus&1"), track->bus1);
    layout->addRow(tr("Bus&2"), track->bus2);
    layout->addRow(tr("&Entry Point"), track->entryPoint);
    layout->addRow(tr("E&xit Point"), track->exitPoint);
    layout->addWidget(okButton);
    layout->addWidget(cancelButton);
	setLayout(layout);
}

void TrackDialog::connectSignals() {
	connect(okButton, &QPushButton::clicked, this, &TrackDialog::accept);
	connect(cancelButton, &QPushButton::clicked, this, &TrackDialog::reject);
    connect(browseButton, &QPushButton::clicked, this, &TrackDialog::browseFiles);
}

QString TrackDialog::browseFiles() const {
	QString filePath = QFileDialog::getOpenFileName(
		const_cast<TrackDialog*>(this),
		tr("Select File"),
		Settings::getInstance()->getPathMedia(),
        tr("Archivos de audio (*.mp3 *.wav *.flac);;Todos los archivos (*)")
	);
	if (!filePath.isEmpty()) {
    	track->setFilePath(filePath);
		QDir dir;
		Settings::getInstance()->setPathMedia(dir.absoluteFilePath(filePath));
	}
    return filePath;
}
